# Interactions
execute as @e[type=interaction,tag=bank_interaction] on target run function galaxyseconomy:initialization/interactions
execute as @e[type=interaction,tag=bank_interaction] on attacker run function galaxyseconomy:initialization/interactions
# Calculator
execute as @a run scoreboard players operation @s BalanceInteger = @s Balance
execute as @a run scoreboard players operation @s BalanceInteger /= 100 EconomyNumbers
execute as @a run scoreboard players operation @s BalanceDecimal = @s Balance
execute as @a run scoreboard players operation @s BalanceDecimalStep = @s BalanceInteger
execute as @a run scoreboard players operation @s BalanceDecimalStep *= 100 EconomyNumbers
execute as @a run scoreboard players operation @s BalanceDecimal -= @s BalanceDecimalStep
# Stock Calculator
scoreboard players operation Redstone_Stack Stock = Redstone Stock
scoreboard players operation Redstone_Stack Stock *= 64 EconomyNumbers
scoreboard players operation Lapis_Stack Stock = Lapis Stock
scoreboard players operation Lapis_Stack Stock *= 64 EconomyNumbers
scoreboard players operation Iron_Stack Stock = Iron Stock
scoreboard players operation Iron_Stack Stock *= 64 EconomyNumbers
scoreboard players operation Copper_Stack Stock = Copper Stock
scoreboard players operation Copper_Stack Stock *= 64 EconomyNumbers
scoreboard players operation Gold_Stack Stock = Gold Stock
scoreboard players operation Gold_Stack Stock *= 64 EconomyNumbers
scoreboard players operation Emerald_Stack Stock = Emerald Stock
scoreboard players operation Emerald_Stack Stock *= 64 EconomyNumbers
scoreboard players operation Netherite_Stack Stock = Netherite Stock
scoreboard players operation Netherite_Stack Stock *= 64 EconomyNumbers
# Pay
scoreboard players enable @a Pay
execute as @a unless score @s Pay matches 0 if score @s Pay <= @s Balance at @s run function galaxyseconomy:pay
scoreboard players set @a Pay 0
# Show Balance
scoreboard players enable @a ShowBalance
execute if entity @a[scores={ShowBalance=1..}] run function galaxyseconomy:initialization/show_balance
# ID Scores
execute as @a unless score @s EconomyIDs matches 1..2147483647 run function galaxyseconomy:initialization/give_player_id
# Claim Payment Terminal
scoreboard players enable @a ClaimPaymentTerminal
execute as @a[scores={ClaimPaymentTerminal=1..}] run function galaxyseconomy:claim_payment_terminal
scoreboard players set @a ClaimPaymentTerminal 0
# Sell All
execute if entity @a[tag=EconomyBankSubscriber] run function galaxyseconomy:initialization/enable
execute as @a[scores={SellAllRedstone=1..}] run function galaxyseconomy:premium_sell/redstone
execute as @a[scores={SellAllLapis=1..}] run function galaxyseconomy:premium_sell/lapis
execute as @a[scores={SellAllIron=1..}] run function galaxyseconomy:premium_sell/iron
execute as @a[scores={SellAllCopper=1..}] run function galaxyseconomy:premium_sell/copper
execute as @a[scores={SellAllGold=1..}] run function galaxyseconomy:premium_sell/gold
execute as @a[scores={SellAllEmerald=1..}] run function galaxyseconomy:premium_sell/emerald
execute as @a[scores={SellAllNetherite=1..}] run function galaxyseconomy:premium_sell/netherite
# Buy All
execute as @a[scores={BuyAllRedstone=1..1000}] run function galaxyseconomy:initialization/buy_all/redstone
scoreboard players set @a[scores={BuyAllRedstone=1001..}] BuyAllRedstone 0
execute as @a[scores={BuyAllLapis=1..1000}] run function galaxyseconomy:initialization/buy_all/lapis
scoreboard players set @a[scores={BuyAllLapis=1001..}] BuyAllLapis 0
execute as @a[scores={BuyAllIron=1..1000}] run function galaxyseconomy:initialization/buy_all/iron
scoreboard players set @a[scores={BuyAllIron=1001..}] BuyAllIron 0
execute as @a[scores={BuyAllCopper=1..1000}] run function galaxyseconomy:initialization/buy_all/copper
scoreboard players set @a[scores={BuyAllCopper=1001..}] BuyAllCopper 0
execute as @a[scores={BuyAllGold=1..1000}] run function galaxyseconomy:initialization/buy_all/gold
scoreboard players set @a[scores={BuyAllGold=1001..}] BuyAllGold 0
execute as @a[scores={BuyAllEmerald=1..1000}] run function galaxyseconomy:initialization/buy_all/emerald
scoreboard players set @a[scores={BuyAllEmerald=1001..}] BuyAllEmerald 0
execute as @a[scores={BuyAllNetherite=1..1000}] run function galaxyseconomy:initialization/buy_all/netherite
scoreboard players set @a[scores={BuyAllNetherite=1001..}] BuyAllNetherite 0
# Payment Terminal
execute as @e[type=interaction,tag=PaymentTerminal] on target at @s run function galaxyseconomy:initialization/interactions_payterm
execute as @a run scoreboard players operation @s PaymentTerminalToBePayedInteger = @s PaymentTerminalToBePayed
execute as @a run scoreboard players operation @s PaymentTerminalToBePayedInteger /= 100 EconomyNumbers
execute as @a run scoreboard players operation @s PaymentTerminalToBePayedDecimal = @s PaymentTerminalToBePayed
execute as @a run scoreboard players operation @s PaymentTerminalToBePayedDecimalStep = @s PaymentTerminalToBePayedInteger
execute as @a run scoreboard players operation @s PaymentTerminalToBePayedDecimalStep *= 100 EconomyNumbers
execute as @a run scoreboard players operation @s PaymentTerminalToBePayedDecimal -= @s PaymentTerminalToBePayedDecimalStep
execute at @e[type=text_display,tag=PaymentTotal] positioned ^ ^-1.5 ^-0.5 run tag @a[distance=1.5..] remove PaymentSeller
execute at @e[type=text_display,tag=PaymentTotal] positioned ^ ^-1.5 ^-0.5 run tag @p[distance=..1.5] add PaymentSeller
execute as @e[type=text_display,tag=PaymentTotal] at @s positioned ^ ^-1.5 ^-0.5 if entity @p[distance=..1.5,scores={PaymentTerminalLockedIn=0,PaymentTerminalToBePayedDecimal=..9}] run data merge entity @s {text:'[{"text":"|-TOTAL-|\\n$"},{"score":{"name":"@p[tag=PaymentSeller,limit=1]","objective":"PaymentTerminalToBePayedInteger"}},{"text":".0"},{"score":{"name":"@p[tag=PaymentSeller,limit=1]","objective":"PaymentTerminalToBePayedDecimal"}}]'}
execute as @e[type=text_display,tag=PaymentTotal] at @s positioned ^ ^-1.5 ^-0.5 if entity @p[distance=..1.5,scores={PaymentTerminalLockedIn=0,PaymentTerminalToBePayedDecimal=10..}] run data merge entity @s {text:'[{"text":"|-TOTAL-|\\n$"},{"score":{"name":"@p[tag=PaymentSeller,limit=1]","objective":"PaymentTerminalToBePayedInteger"}},{"text":"."},{"score":{"name":"@p[tag=PaymentSeller,limit=1]","objective":"PaymentTerminalToBePayedDecimal"}}]'}
execute as @e[type=text_display,tag=PaymentTotal] at @s positioned ^ ^-1.5 ^-0.5 if entity @p[distance=..1.5,scores={PaymentTerminalLockedIn=1,PaymentTerminalToBePayedDecimal=..9}] run data merge entity @s {text:'[{"text":"|-TOTAL-|\\n$"},{"score":{"name":"@p[tag=PaymentSeller,limit=1]","objective":"PaymentTerminalToBePayedInteger"},"color":"green"},{"text":".0","color":"green"},{"score":{"name":"@p[tag=PaymentSeller,limit=1]","objective":"PaymentTerminalToBePayedDecimal"},"color":"green"}]'}
execute as @e[type=text_display,tag=PaymentTotal] at @s positioned ^ ^-1.5 ^-0.5 if entity @p[distance=..1.5,scores={PaymentTerminalLockedIn=1,PaymentTerminalToBePayedDecimal=10..}] run data merge entity @s {text:'[{"text":"|-TOTAL-|\\n$"},{"score":{"name":"@p[tag=PaymentSeller,limit=1]","objective":"PaymentTerminalToBePayedInteger"},"color":"green"},{"text":".","color":"green"},{"score":{"name":"@p[tag=PaymentSeller,limit=1]","objective":"PaymentTerminalToBePayedDecimal"},"color":"green"}]'}
execute as @e[type=text_display,tag=PaymentTotalShown] at @s at @e[type=text_display,tag=PaymentTotal,limit=1,sort=nearest] positioned ^ ^-1.5 ^-0.5 if entity @p[distance=..1.5,scores={PaymentTerminalLockedIn=1,PaymentTerminalToBePayedDecimal=..9}] run data merge entity @s {text:'[{"text":"|-TOTAL-|\\n$"},{"score":{"name":"@p[tag=PaymentSeller,limit=1]","objective":"PaymentTerminalToBePayedInteger"},"color":"green"},{"text":".0","color":"green"},{"score":{"name":"@p[tag=PaymentSeller,limit=1]","objective":"PaymentTerminalToBePayedDecimal"},"color":"green"}]'}
execute as @e[type=text_display,tag=PaymentTotalShown] at @s at @e[type=text_display,tag=PaymentTotal,limit=1,sort=nearest] positioned ^ ^-1.5 ^-0.5 if entity @p[distance=..1.5,scores={PaymentTerminalLockedIn=1,PaymentTerminalToBePayedDecimal=10..}] run data merge entity @s {text:'[{"text":"|-TOTAL-|\\n$"},{"score":{"name":"@p[tag=PaymentSeller,limit=1]","objective":"PaymentTerminalToBePayedInteger"},"color":"green"},{"text":".","color":"green"},{"score":{"name":"@p[tag=PaymentSeller,limit=1]","objective":"PaymentTerminalToBePayedDecimal"},"color":"green"}]'}
execute as @e[type=text_display,tag=PaymentTotalShown] at @s at @e[type=text_display,tag=PaymentTotal,limit=1,sort=nearest] positioned ^ ^-1.5 ^-0.5 if entity @p[distance=..1.5,scores={PaymentTerminalLockedIn=0}] run data merge entity @s {text:'[{"text":"|-TOTAL-|\\n$-.--"}]'}
execute as @e[type=text_display,tag=PaymentStatus] at @s positioned ^ ^1 ^-1 unless entity @p[distance=..1.5,scores={PaymentTerminalApproved=0..1}] run data merge entity @s {text:'[{"text":"-STATUS-\\n"},{"text":"-------"}]'}
execute as @e[type=text_display,tag=PaymentStatus] at @s positioned ^ ^1 ^-1 if entity @p[distance=..1.5,scores={PaymentTerminalApproved=1}] run data merge entity @s {text:'[{"text":"-STATUS-\\n"},{"text":"APPROVED","color":"green"}]'}
execute as @e[type=text_display,tag=PaymentStatus] at @s positioned ^ ^1 ^-1 if entity @p[distance=..1.5,scores={PaymentTerminalApproved=0}] run data merge entity @s {text:'[{"text":"-STATUS-\\n"},{"text":"DECLINED","color":"red"}]'}
# Reset
execute as @e[type=interaction,tag=PaymentTerminal] run data remove entity @s interaction
execute as @e[type=interaction,tag=PaymentTerminal] run data remove entity @s attack
execute as @e[type=interaction,tag=bank_interaction] run data remove entity @s interaction
execute as @e[type=interaction,tag=bank_interaction] run data remove entity @s attack